const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const habit_logs = sequelize.define(
    'habit_logs',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

logged_at: {
        type: DataTypes.DATE,
      
      

      },

count_completed: {
        type: DataTypes.INTEGER,
      
      

      },

duration_minutes: {
        type: DataTypes.INTEGER,
      
      

      },

is_completed: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

notes: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  habit_logs.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity


















































































































//end loop



    db.habit_logs.belongsTo(db.habits, {
      as: 'habit',
      foreignKey: {
        name: 'habitId',
      },
      constraints: false,
    });




    db.habit_logs.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.habit_logs.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return habit_logs;
};


